unit Unit1; 

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, LResources, Forms, Controls, Graphics, Dialogs,
  ExtCtrls, StdCtrls, ComCtrls, MPlayerCtrl;

type

  { TForm1 }

  TForm1 = class(TForm)
    ButtonMoveUp: TButton;
    ButtonMoveDown: TButton;
    ButtonDelete: TButton;
    ChannelListBox: TListBox;
    SoundLabel: TLabel;
    SoundComboBox: TComboBox;
    MPlayerControl1: TMPlayerControl;
    PanelMoveButtons: TPanel;
    PanelPlayerReal: TPanel;
    PanelPlayerMax: TPanel;
    PanelList: TPanel;
    PanelControl: TPanel;
    List_Player_Splitter: TSplitter;
    Timer1: TTimer;
    SoundTrackBar: TTrackBar;
    procedure ChannelListBoxDragDrop(Sender, Source: TObject; X, Y: Integer);
    procedure ChannelListBoxDragOver(Sender, Source: TObject; X, Y: Integer;
      State: TDragState; var Accept: Boolean);
    procedure FormShow(Sender: TObject);
    procedure PanelMoveButtonsResize(Sender: TObject);
    procedure PanelPlayerMaxResize(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure SoundTrackBarChange(Sender: TObject);
  private
    { private declarations }
  public
    { public declarations }
  end; 

var
  Form1: TForm1; 

implementation

{ TForm1 }

    {  Start the mPlayer - Begin }

procedure TForm1.Timer1Timer(Sender: TObject);
begin
  {
   * Timer1 is only to start the Player after start the application
   * Note: I had try to set the Form1.MPlayerControl1.Play in TForm1.FormShow.
   *       But the mPlayer keep black.
  }
  Form1.MPlayerControl1.Play;
  Form1.Timer1.Enabled := False;
end;



procedure TForm1.FormShow(Sender: TObject);
begin
  Form1.Timer1.Interval := 100;
  Form1.Timer1.Enabled := True;

    {  Start the mPlayer - End }

  { Test Add - Begin }
  form1.ChannelListBox.Items.Add('abc1');
  form1.ChannelListBox.Items.Add('abc2');
  form1.ChannelListBox.Canvas.Pixels[10,10] := clRed;
  form1.ChannelListBox.Canvas.Pixels[11,11] := clRed;
  form1.ChannelListBox.Canvas.Pixels[10,12] := clRed;
  form1.ChannelListBox.Items.Add('abc3');
  form1.ChannelListBox.Items.Add('abc4');
  form1.ChannelListBox.Items.Add('abc5');
  { Test Add - End }
end;

    {  Change the State of the Player - Begin }

procedure SetPlayerReal(Aspect1, Aspect2: Integer);
{
//Version 2
var
  Width, Height: Integer;
}
begin
  {
   * Calculate the position and size of the Player.
   * It's Buggy!
   * Note: div return a integer not a real
  }
{
//Version 2
if (form1.PanelPlayerMax.Width > (Form1.PanelPlayerMax.Height * Aspect1 div Aspect2)) then
    Width := Form1.PanelPlayerMax.Height * Aspect1 div Aspect2
  else
    Width := Form1.PanelPlayerMax.Width; //Edit 15:33
  Height := Width * Aspect1 div Aspect2;
  Form1.PanelPlayerReal.Width := Width;
  Form1.PanelPlayerReal.Height := Height;
  Form1.PanelPlayerReal.Left := (Form1.PanelPlayerMax.Width - Form1.PanelPlayerReal.Width) div 2;
  Form1.PanelPlayerReal.Top := (Form1.PanelPlayerMax.Height - Form1.PanelPlayerReal.Height) div 2;
}
//Version 1
  Form1.PanelPlayerReal.Width := Form1.PanelPlayerMax.Height div Aspect2 * Aspect1;
  Form1.PanelPlayerReal.Height := Form1.PanelPlayerMax.Width div Aspect1 * Aspect2;
  Form1.PanelPlayerReal.Left := (Form1.PanelPlayerMax.Width - Form1.PanelPlayerReal.Width) div 2;
  Form1.PanelPlayerReal.Top := (Form1.PanelPlayerMax.Height - Form1.PanelPlayerReal.Height) div 2;
end;

procedure TForm1.PanelPlayerMaxResize(Sender: TObject);
begin
  SetPlayerReal(4, 3);
end;

    {  Change the State of the Player - End }


    {  Sort of the ChannelListBox - Begin }

procedure TForm1.ChannelListBoxDragOver(Sender, Source: TObject; X, Y: Integer;
  State: TDragState; var Accept: Boolean);
begin
  {
   * The source of the drag must be the Form1.ChannelListBox
   * else we set accept to False. This show the Stop Cursor!
  }
  if Source <> Form1.ChannelListBox then
    Accept := False;
end;

procedure TForm1.ChannelListBoxDragDrop(Sender, Source: TObject; X, Y: Integer);
var
  Destination: Integer;
begin
  if Source = Form1.ChannelListBox then
  begin
    Destination := Form1.ChannelListBox.ItemAtPos(Point(X, Y), True);  // Get the index of the item wher the Cursor is.
    if Destination = -1 then                                // If ther no item it must be the end of the listbox.
      Destination := Form1.ChannelListBox.Items.Count - 1;  // So we move the selectet item to the end of the list box
    Form1.ChannelListBox.Items.Move(Form1.ChannelListBox.ItemIndex, Destination);  //This move the item. The next step is to move the items in the array.
  end
end;

       {  Change MoveButton Size - Begin }

    procedure TForm1.PanelMoveButtonsResize(Sender: TObject);
    begin
      Form1.ButtonMoveUp.Width := (Form1.PanelMoveButtons.Width - 12) div 2;
      Form1.ButtonMoveDown.Width := (Form1.PanelMoveButtons.Width - 12) div 2;
      Form1.ButtonMoveDown.Left := Form1.ButtonMoveUp.Width + Form1.ButtonMoveUp.Left + 2;
      Form1.ButtonDelete.Width := Form1.ButtonMoveUp.Width + Form1.ButtonMoveDown.Width + 2;
    end;

       {  Change MoveButton Size - End }

    {  Sort of the ChannelListBox - End }


    {  Sound Channle - Begin }

procedure TForm1.SoundTrackBarChange(Sender: TObject);
begin
  Form1.SoundLabel.Caption := IntToStr(Form1.SoundTrackBar.Position);
  if Form1.SoundComboBox.Text = 'mPlayer' then
  begin
    Form1.MPlayerControl1.Volume := Form1.SoundTrackBar.Position;
  end
  else
  begin

  end;
end;

    {  Sound Channle - End }

initialization
  {$I unit1.lrs}

end.

